Subject: [PATCH] clk: fix boot panic with non-dev-associated clocks

From: [email-masked] (Sylwester Nawrocki)
Date: Fri, 01 Nov 2013 00:57:26 +0100

On 10/31/2013 08:00 PM, Mike Turquette wrote:
> On Thu, Oct 31, 2013 at 11:54 AM, Olof Johansson<[email-masked]>  wrote:
>> On Thu, Oct 31, 2013 at 11:47 AM, Fabio Estevam<[email-masked]>  wrote:
>>> On Thu, Oct 31, 2013 at 3:07 PM, Olof Johansson<[email-masked]>  wrote:
>>>> On Thu, Oct 31, 2013 at 10:05 AM, Fabio Estevam<[email-masked]>  wrote:
>>>>> Hi Olof,
>>>>>
>>>>> On Thu, Oct 31, 2013 at 2:49 PM, Olof Johansson<[email-masked]>  wrote:
>>>>>> Fixes a panic at boot on many platforms. For example, on imx (wandboard),
>>>>>> I get:
>>>>>
>>>>> With this patch applied console messages appears on 20131031, but it
>>>>> seems we still have other issues:
>>>>
>>>>
>>>> Yeah, there's lots of badness in last night's -next. :(
>>>
>>> If I apply this change:
>>>
>>> --- a/drivers/clk/clkdev.c
>>> +++ b/drivers/clk/clkdev.c
>>> @@ -44,7 +44,7 @@ struct clk *of_clk_get(struct device_node *np, int index)
>>>          of_clk_lock();
>>>          clk = __of_clk_get_from_provider(&clkspec);
>>>
>>> -       if (!IS_ERR(clk)&&  !__clk_get(clk))
>>> +       if (IS_ERR(clk)&&  !__clk_get(clk))
>>>                  clk = ERR_PTR(-ENOENT);
>>
>> That doesn't look right, it'll call __clk_get() with an error code as the clock.
>>
>> Mike, seems like reverting back the clock tree to a known good state
>> (same as yesterday) and re-target 3.14 for the latest changes is a
>> suitable course of action at this time in the release cycle.
>
> I think removal of the MSM series and clock deregistration stuff is
> prudent. The Tegra pull request (with updated fixes) and EFM32 driver
> should be OK.

I agree, I thought the clock deregistration patches is something better
had exposure for couple weeks in -next. It's a bit late now for those
changes unfortunately.

> I'll cull out the questionable bits and force update.

Thanks.

Regards,
Sylwester